<?php
/*
Bietet Funktionen:
PrintFastixTemplateReplace($arTemplate);
GetFastixTemplateReplace($arTemplate);
FastixTemplateCreateElement($array);

benötigt: fastix_funktionen.php
*/

# Laden sonstiger Funktionen
if (file_exists('cms/fastix_funktionen.php')) {
	require_once 'cms/fastix_funktionen.php';
} else {
	require_once '../cms/fastix_funktionen.php';
	$GLOBALS['CONFIG']['LoadPlugin_UrlOptimize']=false;
}


function PrintFastixTemplateReplace($arTemplate) {
	if (! isset($arTemplate['MailAdressenVerstecken']) || (! $arTemplate['MailAdressenVerstecken'])) {
		$s[0]='@';
		$r[0]='<script type="text/javascript">document.write("&#64;")</script><noscript style="display:inline">&#64;</noscript>';
		$str = str_replace($s,$r,GetFastixTemplateReplace($arTemplate));
	} else {
		$str = GetFastixTemplateReplace($arTemplate);
	}
	if (true 
		&& $GLOBALS['CONFIG']['LoadPlugin_UrlOptimize'] 
		&& file_exists('plugins/UrlOptimize.php')
	) {
		include_once 'plugins/UrlOptimize.php';
		$str= UrlOptimize($str);
	}
	 if ( true 
	 	&& isset($GLOBALS['CONFIG']['LoadPlugin_SendFeed']) 
	 	&& 1==$GLOBALS['CONFIG']['LoadPlugin_SendFeed']*1
	 ) {
		$search='</title>';
		$replace='</title>
<link rel="alternate" type="application/rss+xml" title="RSS Newsfeed" href="SendFeed.php" />
';
		$str=str_replace($search, $replace, $str);
	 }
if (function_exists('WriteCache')) {
	WriteCache($str) or die ('Konnte cache nicht schreiben');
}
print $str;
}

function GetFastixTemplateReplace($arTemplate) {
	if(!isset($arTemplate['TemplateFile'])) {
		die ('Fatal: $arTemplate[\'TemplateFile\'] ist nicht gesetzt!'."\n");
	}
	
	fastixCheckFile($arTemplate['TemplateFile'], $right='r');

	$template=file_get_contents($arTemplate['TemplateFile']);
	$keys=array_keys($arTemplate);
	foreach ($keys as $key) {
		if ($key != 'TemplateFile') {
			$arElement=$arTemplate[$key];
			$replace[]=FastixTemplateCreateElement($arElement);
			$search[]='$arTemplate[\''.$key.'\']';
		}
	}
	return str_replace($search, $replace, $template);
}

function FastixTemplateCreateElement($array) {
	$str='';
	$tag_closed=false;

	if (is_array($array) && isset ($array['html-tag'])) {
		if (isset ($array['html-tag']['TagName'])) {
			$array['html-tag']['TagName']=strtolower($array['html-tag']['TagName']);
			$str.='<'.$array['html-tag']['TagName'];
		}

		if (isset ($array['html-tag']['name'])) {
			$str.=' name="'.$array['html-tag']['name'].'"';
		}

		if (isset ($array['html-tag']['id'])) {
			$str.=' id="'.$array['html-tag']['id'].'"';
		}

		if (isset ($array['html-tag']['class'])) {
			$str.=' class="'.$array['html-tag']['class'].'"';
		}

		if (isset ($array['html-tag']['src'])) {
			$str.=' src="'.$array['html-tag']['src'].'"';
		}

		if (isset ($array['html-tag']['width'])) {
			$str.=' width="'.$array['html-tag']['width'].'"';
		}

		if (isset ($array['html-tag']['height'])) {
			$str.=' height="'.$array['html-tag']['height'].'"';
		}

		if (isset ($array['html-tag']['alt'])) {
			$str.=' alt="'.$array['html-tag']['alt'].'"';
		}

		if (isset ($array['html-tag']['style'])) {
			$str.=' style="'.$array['html-tag']['style'].'"';
		}

		if (isset ($array['html-tag']['onmouseover'])) {
			$str.=' onmouseover="'.$array['html-tag']['onmouseover'].'"';
		}

		if (isset ($array['html-tag']['onmouseout'])) {
			$str.=' onmouseout="'.$array['html-tag']['onmouseout'].'"';
		}

		if (isset ($array['html-tag']['onmouseclick'])) {
			$str.=' onmouseclick="'.$array['html-tag']['onmouseclick'].'"';
		}

		if (isset ($array['html-tag']['onmousemove'])) {
			$str.=' onmousemove="'.$array['html-tag']['onmousemove'].'"';
		}

		if (isset ($array['html-tag']['title'])) {
			$str.=' title="'.$array['html-tag']['title'].'"';
		}

		if (isset ($array['html-tag']['break'])) {
			$str.=' break="'.$array['html-tag']['break'].'"';
		}

		if (
			($array['html-tag']['TagName']=='table')
		||
			($array['html-tag']['TagName']=='tr')
        ||
			($array['html-tag']['TagName']=='ol')
        ||
			($array['html-tag']['TagName']=='ul')
        ||
			($array['html-tag']['TagName']=='select')
        ) {
			$str.='>'; 
			if (! isset ($array['html-tag']['innertext'])) {
				$array['html-tag']['innertext']=' ';
			}
			if (isset ($array['html-tag']['rows'])) {
				foreach ($array['html-tag']['rows'] as $row) {
					$str.= FastixTemplateCreateElement($row);
				}
			$str.='</'.$array['html-tag']['TagName'].'>';
			$tag_closed=true;
			}
		}
		if (!$tag_closed) {
			if (isset ($array['html-tag']['innertext'])) {
				$str.='>'.$array['html-tag']['innertext'].'</'.$array['html-tag']['TagName'].'>';
			} else {
				$str.=' />';
			}
		}
		return $str;
	} else {
		return $array;
	}
}